#ifndef __FRAMEWORK__RLE_INPUT_BUFFER_H__INCLUDED__
#define __FRAMEWORK__RLE_INPUT_BUFFER_H__INCLUDED__

#include "InputBuffer.h"


FRAMEWORK_BEGIN


class RLEInputBuffer :	public InputBuffer
{
public:
	typedef	InputBuffer		_Base;
	typedef	RLEInputBuffer	_Type;

protected:
	const uint8_t	nWordLength;
	uint8_t			*word,
					nWordIndex;
	int_t			nRemaining;
	bool			bCompressed;

	virtual void	_read(uint8_t *pEl);
	virtual int_t	_read(uint8_t *_buffer, int_t length);
	virtual int_t	_skip(int_t length);

public:
	RLEInputBuffer(	const char *szFilename,
					const uint8_t _nWordLength = 1	);
	RLEInputBuffer(	const string &strFilename,
					const uint8_t _nWordLength = 1	);
	~RLEInputBuffer();

	inline int_t	skip_uncompressed(int_t length)
	{
		if(length < 0)
			throw InvalidArgumentException(getErrorMessage("length < 0"));
		if(!length)
			return 0;

		return _Base::_skip(length);
	}
};


FRAMEWORK_END
#endif
