#ifndef __FRAMEWORK__TIMER_H__INCLUDED__
#define __FRAMEWORK__TIMER_H__INCLUDED__

#include "framework.h"

#ifdef _WINDOWS
#include "_windows.h"
#else
#include "RealtimeClient.h"
#endif


FRAMEWORK_BEGIN


#ifdef _WINDOWS
FRAMEWORK_EXPORT class Timer
#else
FRAMEWORK_EXPORT class Timer : protected RealtimeClient
#endif
{
protected:
#ifdef _WINDOWS
	static HANDLE	hTimerQueue;
	HANDLE			hTimer;
#else
	timer_t	timerId;
#endif

	virtual	void	onTimeout() = 0;

public:
			Timer();
	virtual	~Timer();

			void	set(const double &dDelaySeconds, const double &dIntervalSeconds);
	inline	void	set(const double &dSeconds)
	{	set(dSeconds, dSeconds);	}


#ifdef _WINDOWS
	friend	VOID CALLBACK _timer_callback(PVOID, BOOLEAN);
#else
	friend	void _timer_callback(int, siginfo_t *, void *);
#endif
};


#ifdef _WINDOWS
VOID CALLBACK _timer_callback(PVOID lpParameter, BOOLEAN TimerOrWaitFired);
#else
void _timer_callback(int, siginfo_t *, void *);
#endif


FRAMEWORK_END
#endif
