#ifndef __FRAMEWORK___ALLOCATOR_H__INCLUDED__
#define __FRAMEWORK___ALLOCATOR_H__INCLUDED__

#include "Error.h"


FRAMEWORK_BEGIN


class __AllocatorBase
{
public:
	typedef __AllocatorBase	_Type;


private:
	// ensure the allocator is properly copied using the __copy() member
	inline __AllocatorBase(_Type &ref)
	{	/* nothing to do */	}

	inline _Type &	operator =(_Type &ref)
	{	/* nothing to do */	}


public:
	inline __AllocatorBase()
	{	/* nothing to do */	}
};


template <class __Type> class _StaticAllocatorBase
{
public:
	typedef	_StaticAllocatorBase<__Type>	_Type;


	inline _StaticAllocatorBase()
	{	/* nothing to do */	}


	// can't compile Reference template without this
	static __Type *		__new()
	{	throw NotSupportedError(getErrorMessage("can't create new *STATIC* allocator"));	}
	virtual __Type *	__copy() const
	{	throw NotSupportedError(getErrorMessage("can't create copy of a *STATIC* allocator"));	}
	virtual void		__delete()
	{	throw NotSupportedError(getErrorMessage("can't delete a *STATIC* allocator"));	}
};


FRAMEWORK_END
#endif
