#ifndef __GRAPHICS__FRAMERATE_H__INCLUDED__
#define __GRAPHICS__FRAMERATE_H__INCLUDED__

#include <list>

#include "graphics.h"


GRAPHICS_BEGIN


class Framerate
{
protected:
	typedef list<uint_t>	TickList;


	const uint_t	nLength;
	TickList		lTicks;


public:
	Framerate(const uint_t _nLength = 15) : nLength(_nLength)
	{	/* nothing to do */	}
	~Framerate()
	{	/* nothing to do */	}


	void	addFrame(const uint_t nTicks)
	{	lTicks.push_front(nTicks);
		lTicks.resize(nLength + 1);		}

	float	getFrameTime() const
	{	return lTicks.size() ? (float)(lTicks.front() - lTicks.back()) / 1000.0f / nLength : 0.0f;	}

	float	getFrameRate() const
	{	float	fFrameTime = getFrameTime();
		return fFrameTime ? 1.0f / fFrameTime : -1.0f;	}
};


GRAPHICS_END
#endif
