#ifndef __GRAPHICS__SQUARE_MATRIX_H__INCLUDED__
#define __GRAPHICS__SQUARE_MATRIX_H__INCLUDED__

#include "Matrix.h"


GRAPHICS_BEGIN


template <class NumberType, uint_t SIZE> class SquareMatrix :
	public Matrix<NumberType, SIZE, SIZE>
{
public:
	typedef Matrix<NumberType, SIZE, SIZE>	_Base;
	typedef SquareMatrix<NumberType, SIZE>	_Type;

	inline SquareMatrix<NumberType, SIZE>()\
	{	/* nothing to do */	}\
	inline SquareMatrix<NumberType, SIZE>(NumberType *pMatrix) :		_Base(pMatrix)\
	{	/* nothing to do */	}\
	inline SquareMatrix<NumberType, SIZE>(const NumberType *pMatrix) :	_Base(pMatrix)\
	{	/* nothing to do */	}\
	inline SquareMatrix<NumberType, SIZE>(const _TopBase &matrix) :		_Base(matrix)\
	{	/* nothing to do */	}\

	inline _Type &	operator =(NumberType *pMatrix)
	{	_Base::operator =(pMatrix);
		return *this;				}
	inline _Type &	operator =(const NumberType *pMatrix)
	{	_Base::operator =(pMatrix);
		return *this;				}
	inline _Type &	operator =(const _TopBase &matrix)
	{	_Base::operator =(matrix);
		return *this;				}

	_Type &			unity()
	{
		_copyBeforeWrite();
		for(uint_t i = 0; i < SIZE * SIZE; i++)
			_element(i) = (NumberType)(i % (SIZE + 1) ? 0.0 : 1.0);
		return *this;
	}
	static _Type	getUnity()
	{
		_Type	matrix;
		matrix.unity();
		return matrix;
	}

	inline _Type &	multiplyLeft(const _TopBase &mLeft)
	{	return *this = mLeft * (*this);		}
	inline _Type &	multiplyRight(const _TopBase &mRight)
	{	return *this = (*this) * mRight;	}
};


GRAPHICS_END
#endif
