#ifndef __GRAPHICS__SUNRAY_H__INCLUDED__
#define __GRAPHICS__SUNRAY_H__INCLUDED__

#include "Object3.h"


GRAPHICS_BEGIN


class Sunray : public Object3
{
protected:
	static Texture::Reference	rTexture;
	static Vector				vDirection,
								vPosition;
	static float				r,
								g,
								b,
								fDepth,
								fLength,
								fTurbolence;
	float						age,
								vx,
								vz;


	virtual void	_load();
	virtual void	_remove();

	virtual void	_glLoad();
	virtual void	_glRemove();

	virtual void	_glRender();


public:
	inline Sunray() :	age(0.0f)
	{	/* nothing to do */	}


	static Group3 *		create(const uint_t &count);


	static inline void	direction(const Vector &_direction)
	{	vDirection = _direction;	}
	static inline void	position(const Vector &_position)
	{	vPosition = _position;	}
	static inline void	colour(const float &_r, const float &_g, const float &_b)
	{	r = _r;	g = _g;	b = _b;	}
	static inline void	length(const float &_length)
	{	fLength = _length;	}
	static inline void	turbolence(const float &_turbolence)
	{	fTurbolence = _turbolence;	}
	static inline void	depth(const float &_depth)
	{	fDepth = _depth;	}

	static inline void	texture(Texture::Reference &_texture)
	{	rTexture = _texture;	}


	// save the camera position
	virtual void		cameraPosition(const Vector &camera);


	virtual bool		advance(float time);


	virtual void		glReload();

	virtual void		glBind();
};


GRAPHICS_END
#endif
