#include <aquawars/aquawars.h>


AquaWars	g_aquaWars;
Application	*g_pApp = &g_aquaWars;


AquaWars::AquaWars() :	simulation(),
						SDLApplication("AquaWars - Return Of Luzi")
{	simulation.application(this);
	setScene(&simulation);			}


void AquaWars::onInit()
{	simulation.setInterval(1000 / 60);	}

void AquaWars::onKeyDown(SDL_keysym &keysym)
{
	switch(keysym.sym)
	{
	case SDLK_w:
		simulation.increasingPower(true);
		break;
	case SDLK_s:
		simulation.decreasingPower(true);
		break;

	case SDLK_F5:
		simulation.zoomIn();
		break;
	case SDLK_F6:
		simulation.zoomOut();
		break;

	case SDLK_F9:
		simulation.toggleTextureFading();
		break;

	case SDLK_SPACE:
		simulation.skip();
		break;

	case SDLK_9:
		simulation._win();
		break;
	case SDLK_0:
		simulation._lose();
		break;
	case SDLK_g:
		simulation._toggleGod();
		break;
	case SDLK_r:
		simulation._repair();
		break;
	case SDLK_f:
		simulation._refill();
		break;

	default:
		SDLApplication::onKeyDown(keysym);
		break;
	}
}

void AquaWars::onKeyUp(SDL_keysym &keysym)
{
	switch(keysym.sym)
	{
	case SDLK_w:
		simulation.increasingPower(false);
		break;
	case SDLK_s:
		simulation.decreasingPower(false);
		break;

	default:
		SDLApplication::onKeyUp(keysym);
		break;
	}
}

void AquaWars::onMouseMove(SDL_MouseMotionEvent &mme)
{
	if(mme.state & SDL_BUTTON(3))
		simulation.rotateView(-mme.xrel, -mme.yrel);
	else
		simulation.subDirection(-mme.xrel, -mme.yrel);
}

void AquaWars::onMouseDown(SDL_MouseButtonEvent &mbe)
{
	switch(mbe.button)
	{
	case 1:
		simulation.fire(true);
		break;
	case 2:
		simulation.detonate();
		break;

	case 3:
		simulation.resetView(false);
		break;

	case 4:
		simulation.nextWeapon();
		break;
	case 5:
		simulation.previousWeapon();
		break;

	default:
		SDLApplication::onMouseDown(mbe);
		break;
	}
}

void AquaWars::onMouseUp(SDL_MouseButtonEvent &mbe)
{
	switch(mbe.button)
	{
	case 1:
		simulation.fire(false);
		break;
	case 3:
		simulation.resetView(true);
		break;

	default:
		SDLApplication::onMouseUp(mbe);
		break;
	}
}

void AquaWars::onExit()
{	simulation.cancel();
	simulation.wait();	}
