#include <aquawars/HUD.h>

#include <graphics/Scene.h>

#include <aquawars/ObjectTypes.h>
#include <aquawars/Vehicle.h>


GRAPHICS_BEGIN


void HUD::_load()
{
	if(!rFont.isEmpty())
		rFont->load();

	m_tex_shipTop->load();
	m_tex_shipBehind->load();
	m_tex_shield->load();
	m_tex_performance->load();
	m_tex_scala->load();
	m_tex_radar->load();
	m_tex_scan->load();
	m_tex_echo->load();
	m_tex_border->load();
	m_tex_borderMask->load();
	m_tex_glassBottom->load();
	m_tex_glassTop->load();
}
void HUD::_remove()
{
	if(!rFont.isEmpty())
		rFont->remove();

	m_tex_shipTop->remove();
	m_tex_shipBehind->remove();
	m_tex_shield->remove();
	m_tex_performance->remove();
	m_tex_scala->remove();
	m_tex_radar->remove();
	m_tex_scan->remove();
	m_tex_echo->remove();
	m_tex_border->remove();
	m_tex_borderMask->remove();
	m_tex_glassBottom->remove();
	m_tex_glassTop->remove();
}


void HUD::_glLoad()
{
	if(!rFont.isEmpty())
		rFont->glLoad();

	m_tex_shipTop->glLoad();
	m_tex_shipBehind->glLoad();
	m_tex_shield->glLoad();
	m_tex_performance->glLoad();
	m_tex_scala->glLoad();
	m_tex_radar->glLoad();
	m_tex_scan->glLoad();
	m_tex_echo->glLoad();
	m_tex_border->glLoad();
	m_tex_borderMask->glLoad();
	m_tex_glassBottom->glLoad();
	m_tex_glassTop->glLoad();
}

void HUD::_glRemove()
{
	if(!rFont.isEmpty())
		rFont->glRemove();

	m_tex_shipTop->glRemove();
	m_tex_shipBehind->glRemove();
	m_tex_shield->glRemove();
	m_tex_performance->glRemove();
	m_tex_scala->glRemove();
	m_tex_radar->glRemove();
	m_tex_scan->glRemove();
	m_tex_echo->glRemove();
	m_tex_border->glRemove();
	m_tex_borderMask->glRemove();
	m_tex_glassBottom->glRemove();
	m_tex_glassTop->glRemove();
}


/////////////////////////////////// RENDER HUD \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	Zeichnet alle Elemente des Head-Up-Displays.
/////
/////////////////////////////////// RENDER HUD \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
void HUD::_glRender()
{	  
	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);

	int x, y;
	
	//glDisable(GL_DEPTH_TEST);	
	glEnable(GL_BLEND);

	// Umschalten auf 3D-Projektion.
	//enable2D();	

		
	/********************   Displays   ************************/
	// Linkes Display.
	m_tex_glassBottom->glBind();
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor3f(0.7f, 0.7f, 0.7f);

	x = 300;
	y = 182;
	
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x + 100,	0	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,			y	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(0,			y	);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(0,			0	);
	glEnd();

	// Rechtes Display.
	x = viewport[2];
	y = 182;

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x,			0	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x,			y	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x - 300,	y	);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x - 400,	0	);
	glEnd();
	
	// Oberes Display.
	m_tex_glassTop->glBind();
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor3f(0.7f, 0.7f, 0.7f);
	
	x = viewport[2]/2 - 211;
	y = viewport[3] - 70;

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.7f); glVertex2i(x + 424,	y 		);
		glTexCoord2f(0.0f, 0.4f); glVertex2i(x + 424 ,	y + 70	);
		glTexCoord2f(1.0f, 0.4f); glVertex2i(x,			y + 70	);
		glTexCoord2f(1.0f, 0.7f); glVertex2i(x,			y 		);
	glEnd();
	
	y = viewport[3] - 120;

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x + 374,	y 		);
		glTexCoord2f(0.0f, 0.7f); glVertex2i(x + 424 ,	y + 50	);
		glTexCoord2f(1.0f, 0.7f); glVertex2i(x,			y + 50	);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x + 50,	y 		);
	glEnd();
		
	// Linke Rahmenmaske.
	glBlendFunc(GL_DST_COLOR,GL_ZERO);
	m_tex_borderMask->glBind();
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

	x = 200;
	y = 200;

	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x,	y - 58	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,	y		);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(0,	y		);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(0,	y - 58	);
	glEnd();

	// Rechte Rahmenmaske.
	x = viewport[2];
	y = 200;

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x,			y - 58	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x,			y		);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x - 200,	y		);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x - 200,	y - 58	);
	glEnd();

	// Linke obere Rahmenmaske.
	x = viewport[2]/2 - 170;
	y = viewport[3];

	glBegin(GL_QUADS);
		glTexCoord2f(0.55f, 1.0f); glVertex2i(x,		y 		);
		glTexCoord2f(0.55f, 0.0f); glVertex2i(x - 58,	y		);
		glTexCoord2f(1.0f, 0.0f);  glVertex2i(x - 58 ,	y - 70	);
		glTexCoord2f(1.0f, 1.0f);  glVertex2i(x,		y - 70	);
	glEnd();

	// Rechte obere Rahmenmaske.
	x = viewport[2]/2 + 230;
	y = viewport[3];

	glBegin(GL_QUADS);
		glTexCoord2f(0.55f, 0.0f); glVertex2i(x,		y 		);
		glTexCoord2f(0.55f, 1.0f); glVertex2i(x - 58,	y		);
		glTexCoord2f(1.0f, 1.0f);  glVertex2i(x - 58 ,	y - 70	);
		glTexCoord2f(1.0f, 0.0f);  glVertex2i(x,		y - 70	);
	glEnd();

	// Linker Rahmen.
	glBlendFunc(GL_ONE, GL_ONE);
	m_tex_border->glBind();

	x = 200;
	y = 200;

	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x,	y - 58	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,	y		);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(0,	y		);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(0,	y - 58	);
	glEnd();

	// Rechter Rahmen.
	x = viewport[2];
	y = 200;

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x,			y - 58	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x,			y		);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x - 200,	y		);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x - 200,	y - 58	);
	glEnd();

	// Linker oberer Rahmen.
	x = viewport[2]/2 - 170;
	y = viewport[3];

	glBegin(GL_QUADS);
		glTexCoord2f(0.55f, 1.0f); glVertex2i(x,		y 		);
		glTexCoord2f(0.55f, 0.0f); glVertex2i(x - 58,	y		);
		glTexCoord2f(1.0f, 0.0f);  glVertex2i(x - 58 ,	y - 70	);
		glTexCoord2f(1.0f, 1.0f);  glVertex2i(x,		y - 70	);
	glEnd();

	// Rechter oberer Rahmen.
	x = viewport[2]/2 + 230;
	y = viewport[3];

	glBegin(GL_QUADS);
		glTexCoord2f(0.55f, 0.0f); glVertex2i(x,		y 		);
		glTexCoord2f(0.55f, 1.0f); glVertex2i(x - 58,	y		);
		glTexCoord2f(1.0f, 1.0f);  glVertex2i(x - 58 ,	y - 70	);
		glTexCoord2f(1.0f, 0.0f);  glVertex2i(x,		y - 70	);
	glEnd();
	
	/*****************  Schieldanzeigen  ***********************/
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	m_tex_shield->glBind();
	
	x = viewport[2] - 284;
	y = 15;

	// Ansicht von hinten:
	// Linke Schieldanzeige fr die Ansicht von hinten.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[4]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[4]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[4]][2], 0.7f);

	glBegin(GL_QUADS);	
		glTexCoord2f(0.0f, 1.0f);glVertex2i(x,		y + 30	);
		glTexCoord2f(0.0f, 0.0f);glVertex2i(x - 7,	y + 22	);
		glTexCoord2f(1.0f, 0.0f);glVertex2i(x - 7,	y + 8	);
		glTexCoord2f(1.0f, 1.0f);glVertex2i(x,		y		);	
	glEnd();

	// Obere Schieldanzeige fr die Ansicht von hinten.	
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[0]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[0]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[0]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 54,	y + 37	);
		glVertex2i(x + 8,	y + 37	);
		glVertex2i(x ,		y + 30	);
		glVertex2i(x + 62,	y + 30	);	
	glEnd();


	// Untere Schieldanzeige fr die Ansicht von hinten.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[1]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[1]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[1]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 62,	y		);
		glVertex2i(x,		y  		);
		glVertex2i(x + 8,	y - 7	);
		glVertex2i(x + 54,	y - 7	);	
	glEnd();


	// Rechte Schieldanzeige fr die Ansicht von hinten.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[5]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[5]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[5]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 69,	y + 22	);
		glVertex2i(x + 62,	y + 30	);
		glVertex2i(x + 62,	y		);
		glVertex2i(x + 69,	y + 8	);	
	glEnd();
	
	// Ansichtvon oben:
	// Linke Schieldanzeige fr die Ansicht von oben.
	y = 65;	
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[4]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[4]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[4]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x,		y + 100	);
		glVertex2i(x - 7,	y + 92	);
		glVertex2i(x - 7,	y + 8	);
		glVertex2i(x,		y		);	
	glEnd();

	// Obere Schieldanzeige fr die Ansicht von oben.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[2]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[2]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[2]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 54,	y + 107	);
		glVertex2i(x + 8,	y + 107	);
		glVertex2i(x ,		y + 100	);
		glVertex2i(x + 62,	y + 100	);	
	glEnd();


	// Untere Schieldanzeige fr die Ansicht von oben.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[3]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[3]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[3]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 62,	y		);
		glVertex2i(x,		y  		);
		glVertex2i(x + 8,	y - 7	);
		glVertex2i(x + 54,	y - 7	);	
	glEnd();


	// Rechte Schieldanzeige fr die Ansicht von oben.
	glColor4f(m_fl_shieldColors[m_int_shieldColorIndex[5]][0], 
			  m_fl_shieldColors[m_int_shieldColorIndex[5]][1], 
			  m_fl_shieldColors[m_int_shieldColorIndex[5]][2], 0.7f);

	glBegin(GL_QUADS);	
		glVertex2i(x + 69,	y + 92	);
		glVertex2i(x + 62,	y + 100	);
		glVertex2i(x + 62,	y		);
		glVertex2i(x + 69,	y + 8	);	
	glEnd();

	// Schiffanzeige von hinten.
	m_tex_shipBehind->glBind();

	glColor4f(0.0f, 0.35f, 0.0f, 0.7f);

	y = 15;
	
	glBegin(GL_QUADS);	
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x + 60,  y			);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x + 60,  y + 30	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,		  y + 30	);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x,		  y			);	
	glEnd();
		
	// Schiffanzeige von oben.
	m_tex_shipTop->glBind();
	
	glColor4f(0.0f, 0.35f, 0.0f, 0.7f);
	
	y = 65;

	glBegin(GL_QUADS);	
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x + 60,  y			);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x + 60,  y + 100	);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,		  y + 100	);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x,		  y			);	
	glEnd();

	/****************	Display-Elemente	********************/
	
	// Transmissionsanzeige.
	if(transmissions.size())
	{
		mTransmissions.P();

		Message	&msg = transmissions.front();

		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(1.0f, 1.0f, 1.0f, fTransmissionLife > 0.7f ? 0.7f : fTransmissionLife);
		
		x = viewport[2]/2 - 182;
		y = viewport[3] - 8;

		if(!msg.texture.isEmpty())
		{
			msg.texture->glBindLoad();

			glBegin(GL_QUADS);
				glTexCoord2f(1.0f, 1.0f); glVertex2i(x + 70,	y - 70	);
				glTexCoord2f(1.0f, 0.0f); glVertex2i(x + 70,	y		);
				glTexCoord2f(0.0f, 0.0f); glVertex2i(x,			y		);
				glTexCoord2f(0.0f, 1.0f); glVertex2i(x,			y - 70	);
			glEnd();
		}

		if(!rFont.isEmpty())
		{
			rFont->glBind();
			rFont->_glDraw(msg.text, x + 80, y - 35, Font::alignLowCenter);
		}

		mTransmissions.V();
	}
	
	// Radaranzeige.	
	m_tex_radar->glBind();
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glColor4f(0.0f, 0.35f, 0.0f, 1.0f);

	x = 155;
	y = 10;

	glBegin(GL_QUADS);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x,			y		);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x + 155,	y		); 
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x + 155,	y + 155	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x,			y + 155	);		
	glEnd();

	
	// Radarechos.	
	m_tex_echo->glBind();
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	
	x = 233;
	y = 88;
	
	mRadarObjects.P();
	int_t	size;

	for(list<RadarTarget>::iterator it = lRadarObjects.begin(); it != lRadarObjects.end(); it++) 
	{
		const GLfloat	__x = x + it->x * 70,
						__y = y + it->z * 70;

		if(it->type == c_questItems)
			glColor4f(1.0f, 1.0f, 0.5f, it->alpha);
		else if(it->type == c_projectile)
			glColor4f(1.0f, 0.5f, 0.5f, it->alpha);
		else
			glColor4f(1.0f, 1.0f, 1.0f, it->alpha);

		size = it->type == c_projectile ? 5 : 10;
		
		glBegin(GL_QUADS);
			glTexCoord2f(1.0f, 0.0f); glVertex2f(__x - size, __y - size);
			glTexCoord2f(1.0f, 1.0f); glVertex2f(__x + size, __y - size);
			glTexCoord2f(0.0f, 1.0f); glVertex2f(__x + size, __y + size);
			glTexCoord2f(0.0f, 0.0f); glVertex2f(__x - size, __y + size);
		glEnd();
    }
	mRadarObjects.V();
	
	// Geschwindigkeitsskala.
	m_tex_scala->glBind();

	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glColor4f(0.7f, 0.7f, 0.7f, 0.7f);

	x = 5;
	y = 12;

	glBegin(GL_QUADS);	
		glTexCoord2f(0.0f, 1.0f); glVertex2i(x + 20,	y + 115	);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(x + 20,	y		);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(x + 30,	y		);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(x + 30,	y + 115	);
	glEnd();
	
	// Geschwindigkeitsanzeige.
	m_tex_performance->glBind();
	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glColor4f(1.0f, 1.0f, 1.0f, 0.7f);
	
	x = 20;
	y = 12;

	glBegin(GL_QUADS);	
		glTexCoord2f(0.0f, m_fl_performance);	glVertex2i(x + 20,	y + (int)(115 * m_fl_performance)	);
		glTexCoord2f(0.0f, 0.0f);				glVertex2i(x + 20,	y									);
		glTexCoord2f(1.0f, 0.0f);				glVertex2i(x + 35,	y									);
		glTexCoord2f(1.0f, m_fl_performance);	glVertex2i(x + 35,	y + (int)(115 * m_fl_performance)	);
	glEnd();

	if(!rFont.isEmpty())
	{
		char	str[64];

		x = 72;
		y = 12;

		sprintf(str, "%.0f m\n%.0f km/h", m_fl_depth, m_fl_velocity);
		rFont->glBind();
		rFont->_glDraw(str, x, y, Font::alignLowLow);

		mWeapons.P();
		int		_x = 54 + 9 * vWeapons.size();
		for(uint_t i = 0; i < vWeapons.size(); i++)
		{
			if(i == m_int_weaponIndex)
				glColor4f(1.0f, 1.0f, 1.0f, 0.7f);
			else
				glColor4f(0.5f, 0.5f, 0.5f, 0.7f);

			rFont->_glDraw(vWeapons[i].getName(), viewport[2] - 190, _x - 18 * i, Font::alignLowCenter);
			sprintf(str, "%u", vWeapons[i].getAmmunition());
			rFont->_glDraw(str, viewport[2] - 20, _x - 18 * i, Font::alignHighCenter);
		}
		mWeapons.V();
	}


	glDisable(GL_BLEND);

	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
}


///////////////////////////////////// HUD \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////	Unser HUD-Konstruktor.
/////
///////////////////////////////////// HUD \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
HUD::HUD() :
	pVehicle(NULL),
	m_fl_radarRange(2500.0f),
	sndTransmission("res/sounds/intercom.wav")
{
	m_int_shieldColorIndex[0] = 0;
	m_int_shieldColorIndex[1] = 0;
	m_int_shieldColorIndex[2] = 0;
	m_int_shieldColorIndex[3] = 0;
	m_int_shieldColorIndex[4] = 0;
	m_int_shieldColorIndex[5] = 0;

	for(int i = 0; i < 11; i++)
		m_fl_shieldColors[i][2] = 0.0f;
	
	m_fl_shieldColors[0][0] = 0.0f;
	m_fl_shieldColors[0][1] = 1.0f;
	m_fl_shieldColors[1][0]	= 0.1f;
	m_fl_shieldColors[1][1] = 0.9f;
	m_fl_shieldColors[2][0] = 0.2f;
	m_fl_shieldColors[2][1] = 0.8f;
	m_fl_shieldColors[3][0] = 0.3f;
	m_fl_shieldColors[3][1] = 0.7f;
	m_fl_shieldColors[4][0] = 0.4f;
	m_fl_shieldColors[4][1] = 0.6f;
	m_fl_shieldColors[5][0] = 0.5f;
	m_fl_shieldColors[5][1] = 0.5f;
	m_fl_shieldColors[6][0] = 0.6f;
	m_fl_shieldColors[6][1] = 0.4f;
	m_fl_shieldColors[7][0] = 0.7f;
	m_fl_shieldColors[7][1] = 0.3f;
	m_fl_shieldColors[8][0] = 0.8f;
	m_fl_shieldColors[8][1] = 0.2f;
	m_fl_shieldColors[9][0] = 0.9f;
	m_fl_shieldColors[9][1] = 0.7f;
	m_fl_shieldColors[10][0] = 1.0f;
	m_fl_shieldColors[10][1] = 0.0f;
}


// Setter fr die Texturen.
void HUD::skin(const string &strPath)
{
	m_tex_radar = Texture::create(strPath + "/radar.tga");
	m_tex_performance = Texture::create(strPath + "/motorleistung.tga");
	m_tex_scala = Texture::create(strPath + "/skala.tga");
	m_tex_shipBehind = Texture::create(strPath + "/schiff_hinten.tga");
	m_tex_shipTop = Texture::create(strPath + "/schiff_oben.tga");
	m_tex_border = Texture::create(strPath + "/rahmen.tga");
	m_tex_borderMask = Texture::create(strPath + "/rahmen_maske.tga");
	m_tex_glassBottom = Texture::create(strPath + "/glas_unten.tga");
	m_tex_glassTop = Texture::create(strPath + "/glas_oben.tga");
	m_tex_shield = Texture::create(strPath + "/schield.tga");
	m_tex_echo = Texture::create(strPath + "/echo.tga");
	m_tex_scan = Texture::create(strPath + "/schield.tga");
}


void HUD::message(const char *text)
{
	mTransmissions.P();
	transmissions.push_back(Message(text));
	mTransmissions.V();
}

void HUD::message(const char *text, Texture::Reference texture)
{
	mTransmissions.P();
	transmissions.push_back(Message(text, texture));
	mTransmissions.V();
}

void HUD::message(const string &text)
{
	mTransmissions.P();
	transmissions.push_back(Message(text));
	mTransmissions.V();
}

void HUD::message(const string &text, Texture::Reference texture)
{
	mTransmissions.P();
	transmissions.push_back(Message(text, texture));
	mTransmissions.V();
}


void HUD::glReload()
{
	Object2::glReload();

	if(!rFont.isEmpty())
		rFont->glReload();

	m_tex_shipTop->glReload();
	m_tex_shipBehind->glReload();
	m_tex_shield->glReload();
	m_tex_performance->glReload();
	m_tex_scala->glReload();
	m_tex_radar->glReload();
	m_tex_scan->glReload();
	m_tex_echo->glReload();
	m_tex_border->glReload();
	m_tex_borderMask->glReload();
	m_tex_glassBottom->glReload();
	m_tex_glassTop->glReload();

	for(list<Message>::iterator it = transmissions.begin(); it != transmissions.end(); it++)
		if(!it->texture.isEmpty())
			it->texture->glReload();
}


bool HUD::advance(float time)
{
	// Linkes Display.
	m_fl_performance = pVehicle->getEnginePower();
	m_fl_velocity = pVehicle->getSpeed();
	m_fl_depth = 850.0f - pVehicle->getPositionY();

	if(pScene)
	{
		list<_Object3 *>	objects;
		Vector3<float>		forward(pVehicle->getForward());
		const float			x = pVehicle->getPositionX(),
							y = pVehicle->getPositionY(),
							z = pVehicle->getPositionZ(),
							fx = forward.getX(),
							fy = forward.getY(),
							fz = forward.getZ();
		float				r,
							alpha,
							falpha;
		RadarTarget			rt;

		falpha = atan(fz / fx);
		if(fx < 0.0f)
			falpha += (float)PI;

		pScene->getObjectsInRadius(objects, pVehicle, m_fl_radarRange);

		mRadarObjects.P();
		lRadarObjects.clear();
		for(list<_Object3 *>::iterator it = objects.begin(); it != objects.end(); it++)
			switch((*it)->getCathegoryID())
			{
			case c_vehicle:
			case c_questItems:
			case c_projectile:
				{
					const GLfloat	_x = x - (*it)->getPositionX(),
									_y = y - (*it)->getPositionY(),
									_z = z - (*it)->getPositionZ();

					alpha = atan(_z / _x);
					if(_x < 0.0f)
						alpha += (float)PI;
					alpha = falpha - alpha - (float)PI / 2.0f;

					r = pow((_x * _x + _z * _z) / (m_fl_radarRange * m_fl_radarRange), 0.25f);
					rt.x = r * cos(alpha);
					rt.z = r * sin(alpha);
					
					rt.alpha = 1.0f - abs(_y / m_fl_radarRange);
					rt.type = (*it)->getCathegoryID();

					lRadarObjects.push_back(rt);
					break;
				}
			}
		mRadarObjects.V();
	}
	
	// Rechtes Display.
	const float	*armourValues = pVehicle->getArmour(),
				armourMax = pVehicle->getMaxArmour() / 10.0f;

	m_int_shieldColorIndex[0]	= 10 - (uint_t)((armourValues[0] < 0.0f ? 0.0f : armourValues[0]) / armourMax);
	m_int_shieldColorIndex[1]	= 10 - (uint_t)((armourValues[1] < 0.0f ? 0.0f : armourValues[1]) / armourMax);
	m_int_shieldColorIndex[2]	= 10 - (uint_t)((armourValues[2] < 0.0f ? 0.0f : armourValues[2]) / armourMax);
	m_int_shieldColorIndex[3]	= 10 - (uint_t)((armourValues[3] < 0.0f ? 0.0f : armourValues[3]) / armourMax);
	m_int_shieldColorIndex[4]	= 10 - (uint_t)((armourValues[4] < 0.0f ? 0.0f : armourValues[4]) / armourMax);
	m_int_shieldColorIndex[5]	= 10 - (uint_t)((armourValues[5] < 0.0f ? 0.0f : armourValues[5]) / armourMax);

	mWeapons.P();
	vWeapons.clear();
	vWeapons.reserve(pVehicle->getWeapons().size());
	for(vector<Weapon>::const_iterator it = pVehicle->getWeapons().begin(); it != pVehicle->getWeapons().end(); it++)
		vWeapons.push_back(*it);
	mWeapons.V();
	m_int_weaponIndex = pVehicle->getCurrentWeapon();

	// Oberes Display
	if(fTransmissionLife > 0.0f)
	{
		fTransmissionLife -= time;
		if(fTransmissionLife <= 0.0f)
			transmissions.pop_front();
	}
	else if(transmissions.size())
	{
		fTransmissionLife = 1.0f + transmissions.front().text.size() * 0.1f;
		sndTransmission.start(false);
	}


	return true;
}


GRAPHICS_END
