#include <graphics/Group3.h>

#include <graphics/Camera.h>


GRAPHICS_BEGIN


void Group3::glGetAll(RenderMap &rm, const Vector &vCameraPosition)
{
	mChildren.P();
	for(ObjectSet::iterator it = children.begin(); it != children.end(); it++)
		(*it)->glGetAll(rm, vCameraPosition);
	mChildren.V();
}

void Group3::glGetVisible(RenderMap &rm, Camera *pCamera, const Vector &vCameraPosition)
{
	switch(pCamera->visibility(this))
	{
	case Camera::full:
		mChildren.P();
		for(ObjectSet::iterator it = children.begin(); it != children.end(); it++)
			(*it)->glGetAll(rm, vCameraPosition);
		mChildren.V();
		break;

	case Camera::partial:
		mChildren.P();
		for(ObjectSet::iterator it = children.begin(); it != children.end(); it++)
			(*it)->glGetVisible(rm, pCamera, vCameraPosition);
		mChildren.V();
		break;

	case Camera::none:
	default:
		// nothing to do here
		break;
	}
}


GRAPHICS_END
