#include <graphics/Sphere.h>


GRAPHICS_BEGIN


Sphere::Allocator	Sphere::allocator;


void Sphere::_init(const GLint &_slices, const GLint &_stacks)
{
	slices = _slices;
	stacks = _stacks;
}


void Sphere::_glRender()
{
	gluSphere(pSphere, *pBoundary, slices, stacks);
}


Sphere::Sphere(const GLfloat &_radius, const GLint &_slices,const GLint &_stacks, const bool _bCanCollide, Material *_pMaterial) :
Object3(_bCanCollide, _pMaterial)
{
	boundingSphere(_radius),
	_init(_slices, _stacks);
}

Sphere::Sphere(const Id &id)
{
	boundingSphere(id.radius),
	_init(id.slices, id.stacks);
}

Sphere::~Sphere()
{	_remove();	}


void Sphere::_load()
{
	pSphere = gluNewQuadric();
	gluQuadricDrawStyle(pSphere, GLU_FILL);
}

void Sphere::_remove()
{
	if(pSphere)
	{
		gluDeleteQuadric(pSphere);
		pSphere = NULL;
	}
}


void Sphere::_glLoad()
{	/* nothing to do */	}

void Sphere::_glRemove()
{	/* nothing to do */	}


GRAPHICS_END
