#include <graphics/_SDLThreadBase.h>

#ifdef _WINDOWS
#include <framework/_windows.h>
#endif


GRAPHICS_BEGIN


void _SDLThreadBase::_init()
{
	sdlThread = SDL_CreateThread(__SDLThreadBase_run, this);
	if(!sdlThread)
		throw getLastSDLErrorMessage("failed the create thread");
}


_SDLThreadBase::~_SDLThreadBase()
{
	if(state == running)
		SDL_KillThread(sdlThread);
}


int_t _SDLThreadBase::wait()
{
	int_t	nExitCode;

	SDL_WaitThread(sdlThread, &nExitCode);

	return nExitCode;
}

void _SDLThreadBase::kill()
{
	if(state == running)
	{
		SDL_KillThread(sdlThread);
		state = killed;
	}
}


int __SDLThreadBase_run(void *pThread)
{
	try
	{	return ((_SDLThreadBase *)pThread)->_run();	}
	catch(framework::Error &e)
	{
		e.report();
		return -1;
	}
	catch(framework::Exception &e)
	{
		e.report();
		return -1;
	}
	catch(exception &e)
	{
#if defined(_WINDOWS)
		MessageBox(NULL, e.what(), "Unhandled Exception", MB_ICONERROR);
#else
		cerr << "unhandled exception: " << e.what() << endl;
#endif
		return -1;
	}
}


GRAPHICS_END
