#include <SDL.h>

#include <graphics/_SDLTimerBase.h>
#include <graphics/SDLException.h>


GRAPHICS_BEGIN


void _SDLTimerBase::_setInterval(uint32_t nMs, SDL_NewTimerCallback fnCallback, void *pTimer)
{
	nIntervalMs = nMs;

	if(!sdlTimer)
	{
		sdlTimer = SDL_AddTimer(nIntervalMs, fnCallback, pTimer);
		if(!sdlTimer)
			throw SDLException(getLastSDLError());
	}
}


_SDLTimerBase::_SDLTimerBase() :	sdlTimer(NULL),
									nIntervalMs(0)
{
	if(!SDL_WasInit(SDL_INIT_TIMER))
		if(SDL_InitSubSystem(SDL_INIT_TIMER))
			throw SDLException(getLastSDLError());
}

_SDLTimerBase::~_SDLTimerBase()
{	cancel();	}


void _SDLTimerBase::cancel()
{
	// stop the timer
	if(sdlTimer)
	{
		BOOL	bSuccess = SDL_RemoveTimer(sdlTimer);

		if(!bSuccess)
			throw SDLException(getLastSDLError());
		sdlTimer = NULL;
	}

	// reset interval
	nIntervalMs = 0;
}


GRAPHICS_END
